/**
 * Copyright 2010-2011 (C) The original author or authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.toolazydogs.shiro.struts2;

import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

import org.apache.shiro.web.filter.authc.PassThruAuthenticationFilter;


/**
 * This filter extends {@link PassThruAuthenticationFilter}.  It overrides
 * {@link PassThruAuthenticationFilter#isLoginRequest(ServletRequest, ServletResponse)}
 * so that the login URL's query parameters do not participate in the matching
 * of the servlet request.
 */
public class Struts2AuthenticationFilter extends PassThruAuthenticationFilter
{

    @Override
    protected boolean isLoginRequest(ServletRequest request, ServletResponse response)
    {
        String loginUrl = getLoginUrl();
        if (loginUrl.contains("?")) loginUrl = loginUrl.substring(0, loginUrl.indexOf('?'));
        return pathsMatch(loginUrl, request);
    }
}